Index: branches/2719_HeuristicLab.DatastreamAnalysis/HeuristicLab.DatastreamAnalysis/3.4/DatastreamAnalysisOptimizer.cs
===================================================================
--- branches/2719_HeuristicLab.DatastreamAnalysis/HeuristicLab.DatastreamAnalysis/3.4/DatastreamAnalysisOptimizer.cs	(revision 15868)
+++ branches/2719_HeuristicLab.DatastreamAnalysis/HeuristicLab.DatastreamAnalysis/3.4/DatastreamAnalysisOptimizer.cs	(revision 17980)
@@ -1,6 +1,5 @@
 ﻿#region License Information
-
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -19,11 +18,8 @@
  * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
  */
-
 #endregion
 
 using System;
 using System.Collections.Generic;
-using System.ComponentModel;
-using System.Diagnostics;
 using System.Drawing;
 using System.Linq;
@@ -36,6 +32,6 @@
 using HeuristicLab.Data;
 using HeuristicLab.Optimization;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
 
 namespace HeuristicLab.DatastreamAnalysis {
@@ -48,8 +44,8 @@
   }
 
-  [StorableClass]
   [Item("DatastreamAnalysis Optimizer",
      "The main loop for evaluating ensemble models against a incoming datastream of time series fashion.")]
   [Creatable(CreatableAttribute.Categories.Algorithms)]
+  [StorableType("C2743DA1-081A-4475-8C2C-BFFEACB44134")]
   public class DatastreamAnalysisOptimizer : Executable, IOptimizer, IStorableContent {
     #region properties
@@ -60,4 +56,21 @@
     public IEnumerable<IOptimizer> NestedOptimizers { get; }
 
+    private static Color[] _colorsBrightPastel = {
+                           Color.FromArgb(65, 140, 240),
+                           Color.FromArgb(252, 180, 65),
+                           Color.FromArgb(224, 64, 10),
+                           Color.FromArgb(5, 100, 146),
+                           Color.FromArgb(191, 191, 191),
+                           Color.FromArgb(26, 59, 105),
+                           Color.FromArgb(255, 227, 130),
+                           Color.FromArgb(18, 156, 221),
+                           Color.FromArgb(202, 107, 75),
+                           Color.FromArgb(0, 92, 219),
+                           Color.FromArgb(243, 210, 136),
+                           Color.FromArgb(80, 99, 129),
+                           Color.FromArgb(241, 185, 168),
+                           Color.FromArgb(224, 131, 10),
+                           Color.FromArgb(120, 147, 190)
+                         };
 
     [Storable]
@@ -75,9 +88,9 @@
 
     //private double lastStateValue;
-    private double pR2Sum;
-    private int detectionCount;
-    private int evaluationCount;
-    private double exclusivitySum;
-    private double accuracySum;
+    //private double pR2Sum;
+    //private int detectionCount;
+    //private int evaluationCount;
+    //private double exclusivitySum;
+    //private double accuracySum;
 
     private CancellationTokenSource cancellationTokenSource;
@@ -115,5 +128,5 @@
         if (value == null || value == ensembles)
           return;
-        if (!(value is IProxyEnsembleModel)) throw new ArgumentException("Invaid ensemble model type");
+        if (!(value is IProxyEnsembleModel)) throw new ArgumentException("Invalid ensemble model type");
         DeregisterEnsembleEvents();
         ensembles = value;
@@ -154,15 +167,31 @@
     }
 
-    private DataTable ResultsPeakQualities {
-      get { return ((DataTable) Results["Qualities 2"].Value); }
-    }
+    private DataTable ResultsHorizonQualities {
+      get { return ((DataTable)Results["Qualities 2"].Value); }
+    }
+
+    //private DataTable ResultsPeakQualities {
+    //  get { return ((DataTable) Results["Qualities 2"].Value); }
+    //}
 
     private const string ResultsQualitiesMSE = "Mean squared error";
     private const string ResultsQualitiesPR2 = "Pearson R²";
 
+    private ExtendedDataTable ResultsConfidenceTargets {
+      get { return ((ExtendedDataTable)Results["ConfidenceTargets"].Value); }
+    }
+
+    private ExtendedDataTable ResultsErrorRangeTargets {
+      get { return ((ExtendedDataTable)Results["ErrorRangeTargets"].Value); }
+    }
+
     private DataTable ResultsTargets {
       get { return ((DataTable) Results["Targets"].Value); }
     }
 
+    private DataTable ResultsHorizonTargets {
+      get { return ((DataTable) Results["Horizon Targets"].Value); }
+    }
+
     private DataTable ResultsStateDetection {
       get { return ((DataTable) Results["State Detection"].Value);}
@@ -170,71 +199,75 @@
 
     private const string ResultsTargetsReal = "Real";
+    private const string ResultsTargetRange = "[..]";
 
     private DataBarSet ResultsSWQualitiesBars {
-      get { return (DataBarSet) Results["Ensemble Comparison [SW-Quality]"].Value; }
-    }
-
-    private DataBarSet ResultsSWVotingBars {
-      get { return (DataBarSet) Results["Ensemble Comparison [SW-Voting]"].Value; }
-    }
-
-    private DataBarSet ResultsSonarQualitiesBars {
-      get { return (DataBarSet)Results["Ensemble Comparison [Sonar-Quality]"].Value; }
-    }
-
-    private DataBarSet ResultsSWPeakQualitiesBars {
-      get { return (DataBarSet)Results["Ensemble Comparison [SW-PeakQuality]"].Value; }
-    }
-
-    private double ResultsMeanPR2 {
-      get { return ((DoubleValue) Results["Mean PR2"].Value).Value; }
-      set { ((DoubleValue)Results["Mean PR2"].Value).Value = value; }
-    }
-
-    private double ResultsDetectionAccuracy {
-      get { return ((DoubleValue)Results["Detection Accuracy"].Value).Value; }
-      set { ((DoubleValue)Results["Detection Accuracy"].Value).Value = value; }
-    }
-
-    private double ResultsDetectionExclusivity {
-      get { return ((DoubleValue)Results["Detection Exclusivity"].Value).Value; }
-      set { ((DoubleValue)Results["Detection Exclusivity"].Value).Value = value; }
-    }
-
-    //private int ResultsTrueDetectionCount {
-    //  get { return ((IntValue)Results["True Detection Count"].Value).Value; }
-    //  set { ((IntValue)Results["True Detection Count"].Value).Value = value; }
+      get { return (DataBarSet)Results["Ensemble Comparison [SW-Quality]"].Value; }
+    }
+
+    //private DataBarSet ResultsSWVotingBars {
+    //  get { return (DataBarSet) Results["Ensemble Comparison [SW-Voting]"].Value; }
     //}
 
-    //private int ResultsFalseDetectionCount {
-    //  get { return ((IntValue)Results["False Detection Count"].Value).Value; }
-    //  set { ((IntValue)Results["False Detection Count"].Value).Value = value; }
+    //private DataBarSet ResultsSonarQualitiesBars {
+    //  get { return (DataBarSet)Results["Ensemble Comparison [Sonar-Quality]"].Value; }
     //}
 
+    //private DataBarSet ResultsSWPeakQualitiesBars {
+    //  get { return (DataBarSet)Results["Ensemble Comparison [SW-PeakQuality]"].Value; }
+    //}
+
+    //private double ResultsMeanPR2 {
+    //  get { return ((DoubleValue) Results["Mean PR2"].Value).Value; }
+    //  set { ((DoubleValue)Results["Mean PR2"].Value).Value = value; }
+    //}
+
+    //private double ResultsDetectionAccuracy {
+    //  get { return ((DoubleValue)Results["Detection Accuracy"].Value).Value; }
+    //  set { ((DoubleValue)Results["Detection Accuracy"].Value).Value = value; }
+    //}
+
+    //private double ResultsDetectionExclusivity {
+    //  get { return ((DoubleValue)Results["Detection Exclusivity"].Value).Value; }
+    //  set { ((DoubleValue)Results["Detection Exclusivity"].Value).Value = value; }
+    //}
+
     protected void SetupResults() {
-      evaluationCount = 0;
-      //lastStateValue = 0.0;
-      pR2Sum = 0.0;
-      exclusivitySum = 0.0;
-      accuracySum = 0.0;
-      detectionCount = 0;
+      //evaluationCount = 0;
+      //pR2Sum = 0.0;
+      //exclusivitySum = 0.0;
+      //accuracySum = 0.0;
+      //detectionCount = 0;
       Results.Clear();
       Results.Add(new Result("Sliding Window Movements", new IntValue(0)));
       Results.Add(new Result("Qualities 1", new DataTable("Average Pearson R²")));
-      Results.Add(new Result("Qualities 2", new DataTable("Peak Pearson R²")));
+      Results.Add(new Result("Qualities 2", new DataTable("Average Horizon Pearson R²")));
+      //Results.Add(new Result("Qualities 2", new DataTable("Peak Pearson R²")));
+      Results.Add(new Result("ConfidenceTargets", new ExtendedDataTable("ConfidenceTargets")));
+      Results.Add(new Result("ErrorRangeTargets", new ExtendedDataTable("ErrorRangeTargets")));
       Results.Add(new Result("Targets", new DataTable("Targets")));
+      Results.Add(new Result("Horizon Targets", new DataTable("Horizon Targets")));
       Results.Add(new Result("State Detection", new DataTable("State Detection")));
       Results.Add(new Result("Ensemble Comparison [SW-Quality]", new DataBarSet("Ensemble Comparison [SW-Quality]")));
-      Results.Add(new Result("Ensemble Comparison [SW-Voting]", new DataBarSet("Ensemble Comparison [SW-Voting]")));
-      Results.Add(new Result("Ensemble Comparison [Sonar-Quality]", new DataBarSet("Ensemble Comparison [Sonar-Quality]")));
-      Results.Add(new Result("Ensemble Comparison [SW-PeakQuality]", new DataBarSet("Ensemble Comparison [SW-PeakQuality]")));
-      Results.Add(new Result("Mean PR2", new DoubleValue()));
-      Results.Add(new Result("Detection Accuracy", new DoubleValue()));
-      Results.Add(new Result("Detection Exclusivity", new DoubleValue()));
+      //Results.Add(new Result("Ensemble Comparison [SW-Voting]", new DataBarSet("Ensemble Comparison [SW-Voting]")));
+      //Results.Add(new Result("Ensemble Comparison [Sonar-Quality]", new DataBarSet("Ensemble Comparison [Sonar-Quality]")));
+      //Results.Add(new Result("Ensemble Comparison [SW-PeakQuality]", new DataBarSet("Ensemble Comparison [SW-PeakQuality]")));
+      //Results.Add(new Result("Mean PR2", new DoubleValue()));
+      //Results.Add(new Result("Detection Accuracy", new DoubleValue()));
+      //Results.Add(new Result("Detection Exclusivity", new DoubleValue()));
 
       ResultsTargets.Rows.Add(new DataRow(ResultsTargetsReal));
+      ResultsHorizonTargets.Rows.Add(new DataRow(ResultsTargetsReal));
+      ResultsConfidenceTargets.Rows.Add(new RangeDataRow(ResultsTargetsReal));
+      ResultsErrorRangeTargets.Rows.Add(new RangeDataRow(ResultsTargetsReal));
+      int i = 1;
       foreach (var ensemble in Ensembles) {
         // targets table
         ResultsTargets.Rows.Add(new DataRow(ensemble.Name));
+        ResultsHorizonTargets.Rows.Add(new DataRow(ensemble.Name));
+        ResultsErrorRangeTargets.Rows.Add(new RangeDataRow(ensemble.Name));
+        ResultsErrorRangeTargets.Rows[ensemble.Name].VisualProperties.Color = _colorsBrightPastel[i];
+        ResultsConfidenceTargets.Rows.Add(new RangeDataRow(ensemble.Name));
+        ResultsConfidenceTargets.Rows[ensemble.Name].VisualProperties.Color = _colorsBrightPastel[i];
+        i++;
 
         ResultsStateDetection.Rows.Add(new DataRow(ensemble.Name));
@@ -243,6 +276,7 @@
         //ResultsQualities.Rows.Add(new DataRow(ensemble.Name + " - " + ResultsQualitiesMSE));
         ResultsQualities.Rows.Add(new DataRow(ensemble.Name));
-
-        ResultsPeakQualities.Rows.Add(new DataRow(ensemble.Name));
+        ResultsHorizonQualities.Rows.Add(new DataRow(ensemble.Name));
+
+        //ResultsPeakQualities.Rows.Add(new DataRow(ensemble.Name));
 
         // qualities (bars)
@@ -250,11 +284,21 @@
 
         // voting (bars)
-        ResultsSWVotingBars.Bars.Add(new DataBar(ensemble.Name, ensemble.ConfidenceThreshold.Start, ensemble.ConfidenceThreshold.End));
+        //ResultsSWVotingBars.Bars.Add(new DataBar(ensemble.Name, ensemble.ConfidenceThreshold.Start, ensemble.ConfidenceThreshold.End));
 
         // sonar quality (bars)
-        ResultsSonarQualitiesBars.Bars.Add(new DataBar(ensemble.Name, ensemble.QualityThreshold.Start, ensemble.QualityThreshold.End));
+        //ResultsSonarQualitiesBars.Bars.Add(new DataBar(ensemble.Name, ensemble.QualityThreshold.Start, ensemble.QualityThreshold.End));
 
         // quality peaks (bars)
-        ResultsSWPeakQualitiesBars.Bars.Add(new DataBar(ensemble.Name, ensemble.QualityThreshold.Start, ensemble.QualityThreshold.End));
+        //ResultsSWPeakQualitiesBars.Bars.Add(new DataBar(ensemble.Name, ensemble.QualityThreshold.Start, ensemble.QualityThreshold.End));
+      }
+
+      foreach (var ensemble in Ensembles) {
+        Color color = ResultsErrorRangeTargets.Rows[ensemble.Name].VisualProperties.Color;
+        color = Color.FromArgb(150, (int)(color.R * 1.0), (int)(color.G * 1.0), (int)(color.B * 1.0));
+        string rowName = ensemble.Name + " " + ResultsTargetRange;
+        ResultsErrorRangeTargets.Rows.Add(new RangeDataRow(rowName));
+        ResultsErrorRangeTargets.Rows[rowName].VisualProperties.Color = color;
+        ResultsConfidenceTargets.Rows.Add(new RangeDataRow(rowName));
+        ResultsConfidenceTargets.Rows[rowName].VisualProperties.Color = color;
       }
     }
@@ -275,5 +319,5 @@
 
     [StorableConstructor]
-    protected DatastreamAnalysisOptimizer(bool deserializing) : base(deserializing) {
+    protected DatastreamAnalysisOptimizer(StorableConstructorFlag _) : base(_) {
     }
 
@@ -302,4 +346,5 @@
       if (datastream != null) RegisterDatastreamEvents();
       if (ensembles != null) RegisterEnsembleEvents();
+      Prepare();
     }
     #endregion
@@ -309,5 +354,4 @@
     public override void Prepare() {
       if (ensembles == null || ensembles.Count == 0 || datastream == null || !datastream.SlidingWindowEvaluationPossible) return;
-      //if (ensembles.SelectMany(x => x.Models).Count() == 0) return;
       base.Prepare();
       OnPrepared();
@@ -428,4 +472,7 @@
       try {
         Run(cancellationToken);
+      } catch(Exception ex) {
+        if (ex is ArgumentOutOfRangeException) throw ex;
+        if (ex is OperationCanceledException) throw ex;
       }
       finally {
@@ -445,17 +492,26 @@
         replayedIndex = 0;
         prepared = false;
-      }
-
-      try {
+
+
+        Setup();
 
         // play and evaluate initial window
         PlayDatastream();
+
+        for (int i = 1; i < Datastream.EvaluationHorizon.Value; i++) {
+          foreach (var ensemble in Ensembles) {
+            ResultsHorizonTargets.Rows[ensemble.Name].Values.Add(double.NaN);
+          }
+        }
+
         //lastStateValue = Datastream.ProblemData.Dataset.GetDoubleValue("h", replayedIndex);
         if (Datastream.SlidingWindowEvaluationPossible) Evaluate();
         replayedIndex = Datastream.FitnessPartition.End;
-
+      }
+
+      try {
         do {
           while(Datastream.SlidingWindowMovementPossible) {
-            cancellationToken.ThrowIfCancellationRequested();
+           cancellationToken.ThrowIfCancellationRequested();
 
             // perform (delayed) window movement
@@ -489,18 +545,31 @@
         var realValue = problemData.Dataset.GetDoubleValue(targetVarName, i);
         ResultsTargets.Rows[ResultsTargetsReal].Values.Add(realValue);
-      }
-    }
-
-    private void Smoothen(double[] estimatedValuesPerRow) {
-      if (Datastream.SlidingWindowEvaluationScheme.Value == Datastream.EvaluationScheme.equal) {
-        var avg = estimatedValuesPerRow.Average();
-        for (int i = 0; i < estimatedValuesPerRow.Length; i++) {
-          estimatedValuesPerRow[i] = avg;
-        }
+        ResultsHorizonTargets.Rows[ResultsTargetsReal].Values.Add(realValue);
+        ResultsErrorRangeTargets.Rows[ResultsTargetsReal].Values.Add(new Tuple<double, double>(realValue, realValue));
+        ResultsConfidenceTargets.Rows[ResultsTargetsReal].Values.Add(new Tuple<double, double>(realValue, realValue));
+      }
+    }
+
+    //private void Smoothen(double[] estimatedValuesPerRow) {
+    //  if (Datastream.SlidingWindowEvaluationScheme.Value == Datastream.EvaluationScheme.equal) {
+    //    var avg = estimatedValuesPerRow.Average();
+    //    for (int i = 0; i < estimatedValuesPerRow.Length; i++) {
+    //      estimatedValuesPerRow[i] = avg;
+    //    }
+    //  }
+    //}
+
+    Dictionary<string, List<double>> estimates;
+
+    private void Setup() {
+      estimates = new Dictionary<string, List<double>>();
+      foreach(var ensemble in Ensembles) {
+        estimates.Add(ensemble.Name, new List<double>());
       }
     }
 
     private void Evaluate() {
-      evaluationCount++;
+
+      //evaluationCount++;
       var problemData = Datastream.ProblemData;
       var dataset = problemData.Dataset;
@@ -510,8 +579,8 @@
       var realValues = dataset.GetDoubleValues(targetVarName, rows);
 
-      int sonarSize = (int)(Datastream.FitnessPartition.Size * Datastream.SlidingWindowSonarRatio.Value);
-      var sonarStart = Datastream.FitnessPartition.End - sonarSize;
-      var sonarRows = Enumerable.Range(sonarStart, sonarSize);
-      var sonarRealValues = dataset.GetDoubleValues(targetVarName, sonarRows);
+      //int sonarSize = (int)(Datastream.FitnessPartition.Size * Datastream.SlidingWindowSonarRatio.Value);
+      //var sonarStart = Datastream.FitnessPartition.End - sonarSize;
+      //var sonarRows = Enumerable.Range(sonarStart, sonarSize);
+      //var sonarRealValues = dataset.GetDoubleValues(targetVarName, sonarRows);
 
       var winningEnsembleName = ensembles[0].Name;
@@ -519,20 +588,24 @@
       var winningEnsembleIdx = 0;
       var ec = 0;
-      bool stateChangeInStep = false;
+      //bool stateChangeInStep = false;
       var curDetectionCount = 0;
-      var changeDetectionCount = 0;
+      //var changeDetectionCount = 0;
       //double curStateValue = 0.0;
 
       foreach (var ensemble in Ensembles) {
 
-        var sonarEstimatedValuesPerModelPerRow = ensemble.Model.Models.Select(x => x.GetEstimatedValues(datastream.ProblemData.Dataset, sonarRows).ToArray());
-        var sonarEstimatedValuesPerRow = Enumerable.Range(0, sonarSize).Select(r => sonarEstimatedValuesPerModelPerRow.Select(m => m[r]).Average()).ToArray();
+        //var sonarEstimatedValuesPerModelPerRow = ensemble.Model.Models.Select(x => x.GetEstimatedValues(datastream.ProblemData.Dataset, sonarRows).ToArray());
+        //var sonarEstimatedValuesPerRow = Enumerable.Range(0, sonarSize).Select(r => sonarEstimatedValuesPerModelPerRow.Select(m => m[r]).Average()).ToArray();
         
-        var estimatedValuesPerModelPerRow = ensemble.Model.Models.Select(x => x.GetEstimatedValues(datastream.ProblemData.Dataset, rows).ToArray());
-        var estimatedValuesPerRow = Enumerable.Range(0, Datastream.FitnessPartition.Size).Select(r => estimatedValuesPerModelPerRow.Select(e => e[r]).Average()).ToArray(); // per row
-        var averageEstimatedValuesPerModel = estimatedValuesPerModelPerRow.Select(x => x.Average()); // per model
-        var averageEstimatedValue = averageEstimatedValuesPerModel.Average();
-
-        // calulate quality
+        var estimatedValuesPerModelPerRow = ensemble.Model.Models.Select(x => x.GetEstimatedValues(datastream.ProblemData.Dataset, rows).ToArray());        
+        double[] estimatedValuesPerRow = Enumerable.Range(0, Datastream.FitnessPartition.Size).Select(r => estimatedValuesPerModelPerRow.Select(e => e[r]).Average()).ToArray(); // per row        
+        
+        //var averageEstimatedValuesPerModel = estimatedValuesPerModelPerRow.Select(x => x.Average()); // per model
+        //var averageEstimatedValue = averageEstimatedValuesPerModel.Average();
+
+
+
+
+        // calulate PR
         //var mse = Math.Pow(averageEstimatedValue - realValues.Average(), 2);
         OnlineCalculatorError error;
@@ -540,35 +613,55 @@
         var pR2 = error == OnlineCalculatorError.None ? pR * pR : 0.0;
 
-        var sonarPR = OnlinePearsonsRCalculator.Calculate(sonarEstimatedValuesPerRow, sonarRealValues, out error);
-        var sonarPR2 = error == OnlineCalculatorError.None ? sonarPR * sonarPR : 0.0;
+        //var sonarPR = OnlinePearsonsRCalculator.Calculate(sonarEstimatedValuesPerRow, sonarRealValues, out error);
+        //var sonarPR2 = error == OnlineCalculatorError.None ? sonarPR * sonarPR : 0.0;
    
         var estimatedValuesPerModelPerRowArr = estimatedValuesPerModelPerRow.ToArray();
         var curPR = 0.0;
         
-        var peakPR = OnlinePearsonsRCalculator.Calculate(estimatedValuesPerModelPerRowArr[0], realValues, out error);
-        for (int i = 1; i < estimatedValuesPerModelPerRow.Count(); i++) {
-          curPR = OnlinePearsonsRCalculator.Calculate(estimatedValuesPerModelPerRowArr[i], realValues, out error);
-          if (curPR > peakPR && error == OnlineCalculatorError.None) {
-            peakPR = curPR;
-          }
-        }
-        var peakPR2 = peakPR * peakPR;
+        //var peakPR = OnlinePearsonsRCalculator.Calculate(estimatedValuesPerModelPerRowArr[0], realValues, out error);
+        //for (int i = 1; i < estimatedValuesPerModelPerRow.Count(); i++) {
+        //  curPR = OnlinePearsonsRCalculator.Calculate(estimatedValuesPerModelPerRowArr[i], realValues, out error);
+        //  if (curPR > peakPR && error == OnlineCalculatorError.None) {
+        //    peakPR = curPR;
+        //  }
+        //}
+        //var peakPR2 = peakPR * peakPR;
+
+        // calculate
+        double mae = OnlineMeanAbsoluteErrorCalculator.Calculate(realValues, estimatedValuesPerRow, out error);
+        //double mse = OnlineMeanSquaredErrorCalculator.Calculate(realValues, estimatedValuesPerRow, out error);
 
         // calculate confidence
-        var cm1 = CalulateEnsembleConfidenceCM1(ensemble, estimatedValuesPerModelPerRow, realValues);
+        //var cm1 = CalulateEnsembleConfidenceCM1(ensemble, estimatedValuesPerModelPerRow, realValues);
 
         int replayAmount = Datastream.FitnessPartition.End - replayedIndex;
         int replayCount = estimatedValuesPerRow.Length - replayAmount;
 
-        Smoothen(estimatedValuesPerRow);
+        //Smoothen(estimatedValuesPerRow);
 
         for (int i = replayedIndex; i < Datastream.FitnessPartition.End; i++) {
           //ResultsTargets.Rows[ensemble.Name].Values.Add(averageEstimatedValue);
+          
+          var estVal = estimatedValuesPerRow[replayCount];
+          var estStdDev = ComputeStdDev(estimatedValuesPerModelPerRow.Select(x => x[replayCount]).ToList());
+
           ResultsTargets.Rows[ensemble.Name].Values.Add(estimatedValuesPerRow[replayCount]);
+          if(Datastream.RollingEvaluationHorizon.Value) {
+            var rollingPrediction = RollingEvaluate(ensemble, i);
+            ResultsHorizonTargets.Rows[ensemble.Name].Values.Add(rollingPrediction);
+          } else {
+            ResultsHorizonTargets.Rows[ensemble.Name].Values.Add(estimatedValuesPerRow[replayCount]);
+          }
+
+
+          ResultsErrorRangeTargets.Rows[ensemble.Name].Values.Add(new Tuple<double, double>(estVal, estVal));
+          ResultsErrorRangeTargets.Rows[ensemble.Name + " " + ResultsTargetRange].Values.Add(new Tuple<double, double>(estVal - mae, estVal + mae));
+          ResultsConfidenceTargets.Rows[ensemble.Name].Values.Add(new Tuple<double, double>(estVal, estVal));
+          ResultsConfidenceTargets.Rows[ensemble.Name + " " + ResultsTargetRange].Values.Add(new Tuple<double, double>(estVal - 1.96*estStdDev, estVal + 1.96*estStdDev));
           replayCount++;
 
           //ResultsQualities.Rows[ensemble.Name + " - " + ResultsQualitiesMSE].Values.Add(mse);
           ResultsQualities.Rows[ensemble.Name].Values.Add(pR2);
-          ResultsPeakQualities.Rows[ensemble.Name].Values.Add(peakPR2);
+          //ResultsPeakQualities.Rows[ensemble.Name].Values.Add(peakPR2);
 
           double amp = (pR2 > ensemble.QualityThreshold.Start) ? 1.0 : 0.0;
@@ -576,7 +669,7 @@
         }
         ResultsSWQualitiesBars.Bars[ensemble.Name].Value = pR2;
-        ResultsSonarQualitiesBars.Bars[ensemble.Name].Value = sonarPR2;
-        ResultsSWVotingBars.Bars[ensemble.Name].Value = cm1;
-        ResultsSWPeakQualitiesBars.Bars[ensemble.Name].Value = peakPR2;
+        //ResultsSonarQualitiesBars.Bars[ensemble.Name].Value = sonarPR2;
+        //ResultsSWVotingBars.Bars[ensemble.Name].Value = cm1;
+        //ResultsSWPeakQualitiesBars.Bars[ensemble.Name].Value = peakPR2;
 
         if (pR2 > ensemble.QualityThreshold.Start)
@@ -594,74 +687,73 @@
       // =================================================
 
-      if (winningEnsemblePR2 > ensembles[winningEnsembleIdx].QualityThreshold.Start) {
-        // Mean PR2
-        pR2Sum += winningEnsemblePR2;
-        detectionCount++;
-        ResultsMeanPR2 = pR2Sum/detectionCount;
-
-        // detection exclusivity --> 1.0 - (x - 1) * (1.0 / n)
-        var fraction = 1.0 / ensembles.Count;
-        var curExclusivity = 1.0 - (curDetectionCount - 1) * fraction;
-        exclusivitySum += curExclusivity;
-        ResultsDetectionExclusivity = exclusivitySum / detectionCount;
-      }
-
-      //double replCount = 0.0;
-      //double accCount = 0.0;
-      //for (int i = replayedIndex; i < Datastream.FitnessPartition.End; i++) {
-      //  replCount++;
-      //  //curStateValue = problemData.Dataset.GetDoubleValue("h", i);
-      //  if (curStateValue <= 0.5 && winningEnsembleIdx == 0 && winningEnsemblePR2 > ensembles[winningEnsembleIdx].QualityThreshold.Start) {
-      //    accCount++;
-      //  } else if (curStateValue > 0.5 && winningEnsembleIdx == 1 && winningEnsemblePR2 > ensembles[winningEnsembleIdx].QualityThreshold.Start) {
-      //    accCount++;
-      //  }
+      //if (winningEnsemblePR2 > ensembles[winningEnsembleIdx].QualityThreshold.Start) {
+      //  // Mean PR2
+      //  pR2Sum += winningEnsemblePR2;
+      //  detectionCount++;
+      //  ResultsMeanPR2 = pR2Sum/detectionCount;
+
+      //  // detection exclusivity --> 1.0 - (x - 1) * (1.0 / n)
+      //  var fraction = 1.0 / ensembles.Count;
+      //  var curExclusivity = 1.0 - (curDetectionCount - 1) * fraction;
+      //  exclusivitySum += curExclusivity;
+      //  ResultsDetectionExclusivity = exclusivitySum / detectionCount;
       //}
-      //accuracySum += accCount / replCount;
-      //ResultsDetectionAccuracy = accuracySum / evaluationCount;
-
-
-
-
-      //if (accCount / replCount > 1.0) {
-      //  Console.WriteLine();
-      //}
-
-      //if(accuracySum / evaluationCount > 1.0) {
-      //  Console.WriteLine();
-      //}
-
-      //if (accCount < replCount && !accDiscount) accDiscount = true;
-      //if (accDiscount && accuracySum/evaluationCount >= 1.0) {
-      //  Console.WriteLine();
-      //}
-
-      //lastStateValue = curStateValue;
-
-      // detection of state change
-      //for (int i = replayedIndex; i < Datastream.FitnessPartition.End; i++) {
-      //  curStateValue = problemData.Dataset.GetDoubleValue("h", i);
-      //  if (lastStateValue > curStateValue || lastStateValue < curStateValue) {
-      //    stateChangeInStep = true;
-      //    changeDetectionCount++;
-      //  }
-      //}
-      //lastStateValue = curStateValue;
-
-      // detection accuracy
-      //if (!stateChangeInStep && winningEnsemblePR2 > ensembles[winningEnsembleIdx].QualityThreshold.Start) {
-      //  // (stable) state - detected
-      //  accuracySum++;
-      //} else if(!stateChangeInStep && winningEnsemblePR2 < ensembles[winningEnsembleIdx].QualityThreshold.Start) {
-      //  // (stable) state - not detected
-      //  // no accuracy points (or penalty)
-      //} else if (stateChangeInStep && winningEnsemblePR2 < ensembles[winningEnsembleIdx].QualityThreshold.Start) {
-      //  // change - detected
-      //  accuracySum++;
-      //} else if (stateChangeInStep && winningEnsemblePR2 > ensembles[winningEnsembleIdx].QualityThreshold.Start) {
-      //  // change - not detected
-      //  // no accuracy points (or penalty)
-      //}
-    }
+
+      OnlineCalculatorError err;
+
+      int size = Datastream.FitnessPartition.Size;
+      int horizon = Datastream.EvaluationHorizon.Value;
+      int start = replayedIndex - size;
+      int end = start + size;
+
+      var realVals = ResultsHorizonTargets.Rows[ResultsTargetsReal].Values;
+      if (replayedIndex >= (size - 1)+horizon && realVals.Count >= end) {
+        
+        var reals = Enumerable.Range(start, size).Select(r => realVals[r]).ToArray();
+
+        foreach (var ensemble in Ensembles) {
+          var estimatedVals = ResultsHorizonTargets.Rows[ensemble.Name].Values;
+
+          if (estimatedVals.Count >= end) {
+            var vals = Enumerable.Range(start, size).Select(r => estimatedVals[r]).ToArray();
+            var pR = OnlinePearsonsRCalculator.Calculate(vals, reals, out err);
+            var pR2 = err == OnlineCalculatorError.None ? pR * pR : 0.0;
+            ResultsHorizonQualities.Rows[ensemble.Name].Values.Add(pR2);
+          }
+        }
+      }
+
+
+    }
+
+    private double RollingEvaluate(ProxyEnsembleModel ensemble, int index) {
+      
+      var variables = datastream.ProblemData.InputVariables
+        .Select(x => x.Value)
+        .Where(x => x != datastream.ProblemData.TargetVariable)
+        .ToList();
+      var ods = datastream.ProblemData.Dataset;
+      var values = new double[1,variables.Count];
+      var rows = Enumerable.Range(0, 1);
+
+      for(int i = 0; i < variables.Count; i++) {
+        values[0,i] = ods.GetDoubleValue(variables[i], index);
+      }
+
+      Dataset ds = new Dataset(variables, values);
+      double estimate = ensemble.Model.GetEstimatedValues(ds, rows).ToArray()[0];
+
+      for(int i = 1; i < datastream.EvaluationHorizon.Value; i++) {
+        values[0, 0] = estimate;
+        for(int v = 0; v < variables.Count-1; v++) {
+          values[0, v + 1] = ds.GetDoubleValue(variables[v], 0);
+        }
+        ds = new Dataset(variables, values);
+        estimate = ensemble.Model.GetEstimatedValues(ds, rows).ToArray()[0];
+      }
+      
+      return estimate;
+    }
+
     private bool accDiscount = false;
 
@@ -879,4 +971,12 @@
 
     #endregion nameditem
+
+    #region Helpers
+    private double ComputeStdDev(List<double> series) {
+      double avg = series.Average();
+      double sumOfSquaredDeviations = series.Sum(val => (val - avg) * (val - avg));
+      return Math.Sqrt(sumOfSquaredDeviations / (series.Count - 1));
+    }
+    #endregion
   }
 }
Index: branches/2719_HeuristicLab.DatastreamAnalysis/HeuristicLab.DatastreamAnalysis/3.4/DatastreamAnalysisUtil.cs
===================================================================
--- branches/2719_HeuristicLab.DatastreamAnalysis/HeuristicLab.DatastreamAnalysis/3.4/DatastreamAnalysisUtil.cs	(revision 15868)
+++ branches/2719_HeuristicLab.DatastreamAnalysis/HeuristicLab.DatastreamAnalysis/3.4/DatastreamAnalysisUtil.cs	(revision 17980)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -21,6 +21,4 @@
 
 using System;
-using HeuristicLab.Collections;
-using HeuristicLab.Core;
 
 namespace HeuristicLab.DatastreamAnalysis {
